/* $Id: main.c,v 1.5 2008/08/18 19:33:13 stacktic Exp $ */

/*
 * Copyright (c) 2008 Arnaud Ysmal.  All Rights Reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#include <err.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include <rump/ukfs.h>

#include "fsu_utils.h"
#include "fsu_mount.h"

static void usage(void);

/*
 * This program allow an user to execute a local command (like a text editor)
 * on a file contained on the image
 */
int
main(int argc, char *argv[])
{
	extern bool exec_standalone;
	struct ukfs *fs;
	int rv;

	exec_standalone = true;
	
	fs = fsu_mount(&argc, &argv, NULL, NULL);
        if (fs == NULL) {
		warn("fsu_mount");
		usage();
		/* NOTREACHED */
	}

	if (argc < 3)
		usage();

	rv = fsu_exec_main(fs, argc, argv);

	ukfs_release(fs, 0);
	return rv;
}

void
usage(void)
{

	fprintf(stderr, 
	  "usage: fsu_exec [MNT_OPTIONS] [fstype] fsdevice command file...\n");
	exit(EXIT_FAILURE);
}
