/* $Id: fsu_file.h,v 1.2 2008/08/18 19:33:24 stacktic Exp $ */

/*
 * Copyright (c) 2008 Arnaud Ysmal.  All Rights Reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef _FSU_FILE_H_
#define _FSU_FILE_H_

#include <stdbool.h>

#define FSU_FILE_BUF_SIZE (8192)

struct ukfs;

typedef struct _fsu_filedesc_s FSU_FILE;

struct _fsu_filedesc_s {
	struct ukfs *fd_ukfs;
	char *fd_name;
	uint8_t fd_buf[FSU_FILE_BUF_SIZE];
	int fd_bpos; /* position in buf */
	int fd_fpos; /* position in the file */
	int fd_last; /* last position in the file buffered */
	bool fd_eof;
	int fd_err;
};

FSU_FILE	*fsu_fopen(struct ukfs *, const char *);
char		fsu_fgetc(FSU_FILE *);
void		fsu_fclose(FSU_FILE *);
void		fsu_rewind(FSU_FILE *);
bool		fsu_feof(FSU_FILE *);
void		fsu_clearerr(FSU_FILE *);
int		fsu_ferror(FSU_FILE *);


#endif /* !_FSU_FILE_H_ */
